import { mount } from 'cypress/vue'
import FormView from './FormView.vue'

describe('<FormView />', () => {
  it('displays title emtpy error', () => {
    mount(FormView)
    .get('[data-testid=title]')
    .type(' ')
    .get('[data-testid=categories]')
    .type('Java,Backend,')
    .get('[data-testid=message]')
    .type('Hello 2')
    .get('[data-testid=btnSubmit]')
    .click()
    .get('[data-testid=errorTitle')
    .should('be.visible')
    .get('[data-testid=errorCategory')
    .should('not.be.visible')
    .get('[data-testid=errorMessage')
    .should('not.be.visible')
  })

  it('displays category empty error', () => {
    mount(FormView)
    .get('[data-testid=title]')
    .type('hello')
    .get('[data-testid=categories]')
    .get('[data-testid=message]')
    .type('Hello 2')
    .get('[data-testid=btnSubmit]')
    .click()
    .get('[data-testid=errorTitle')
    .should('not.be.visible')
    .get('[data-testid=errorCategory')
    .should('be.visible')
    .and('have.text', 'You have to put at least 1 catergory')
    .get('[data-testid=errorMessage')
    .should('not.be.visible')
  })

  it('displays category short text error', () => {
    mount(FormView)
    .get('[data-testid=title]')
    .type('hello')
    .get('[data-testid=categories]')
    .type('J,')
    .get('[data-testid=message]')
    .type('Hello 2')
    .get('[data-testid=errorTitle')
    .should('not.be.visible')
    .get('[data-testid=errorCategory')
    .should('be.visible')
    .and('have.text', 'A category name must contain more than one char')
    .get('[data-testid=errorMessage')
    .should('not.be.visible')
  })

  it('displays message empty error', () => {
    mount(FormView)
    .get('[data-testid=title]')
    .type('hello')
    .get('[data-testid=categories]')
    .type('Java,Backend,')
    .get('[data-testid=message]')
    .type(' ')
    .get('[data-testid=btnSubmit]')
    .click()
    .get('[data-testid=errorTitle')
    .should('not.be.visible')
    .get('[data-testid=errorCategory')
    .should('not.be.visible')
    .get('[data-testid=errorMessage')
    .should('be.visible')
  })

  it('submits without any problems', () => {
    mount(FormView)
      .get('[data-testid=title]')
      .type('hello')
      .get('[data-testid=categories]')
      .type('Java,Backend,')
      .get('[data-testid=message]')
      .type('Hello 2')
      .get('[data-testid=btnSubmit]')
      .click()
      .get('[data-testid=errorTitle')
      .should('not.be.visible')
      .get('[data-testid=errorCategory')
      .should('not.be.visible')
      .get('[data-testid=errorMessage')
      .should('not.be.visible')
  })

  it('deletes correctly a category', () => {
    mount(FormView)
    .get('[data-testid=categories]')
    .type('Java,Backend,')
    .get('[data-testid=errorTitle')
    .should('not.be.visible')
    .get('[data-testid=errorCategory')
    .should('not.be.visible')
    .get('[data-testid=errorMessage')
    .should('not.be.visible')
    .get('[data-testid=categoryContainer]')
    .children()
    .should('have.length', '2')
    .first()
    .click()
    .get('[data-testid=categoryContainer]')
    .should('have.length', '1')
  })

  it('adds correctly multiple categories', () => {
    mount(FormView)
    .get('[data-testid=categories]')
    .type('Java,Backend,')
    .get('[data-testid=errorTitle')
    .should('not.be.visible')
    .get('[data-testid=errorCategory')
    .should('not.be.visible')
    .get('[data-testid=errorMessage')
    .should('not.be.visible')
    .get('[data-testid=categoryContainer]')
    .children()
    .should('have.length', '2')
  })
})
